
/**
 * @author shaozilee
 *
 * BMP format encoder,encode 24bit BMP
 * Not support quality compression
 * 
 */
// Arranged by T. Osaka(2015/8/3)

var fs = require("fs");

function BmpEncoder(imgData, bit, w, h){
	this.buffer = imgData;
	this.width = w;
	this.height = h;
//console.log("w=" + this.width + " h=" + this.height);
	this.extraBytes = this.width % 4;
	if (bit == 24) this.rawSize = this.height * (3 * this.width + this.extraBytes);
	else if (bit == 8) this.rawSize = this.height * (this.width + this.extraBytes);
	else if (bit == -8) this.rawSize = this.height * (this.width + this.extraBytes);
	this.headerSize = 40;
//console.log("ex=" + this.extraBytes + " rgb=" + this.rawSize);

	this.data = [];
	this.flag = "BM";
	/******************header***********************/
	this.reserved = 0;
	if (bit == 24) this.offset = 54;
	else if (bit == 8) this.offset = 54 + 1024;
	else if (bit == -8) this.offset = 54 + 1024;
	this.fileSize = this.rawSize + this.offset;
	this.planes = 1;
	this.bitPP = bit;
	this.compress = 0;
	this.hr = 0;
	this.vr = 0;
	this.colors = 0;
	this.importantColors = 0;


this.encode = function() {
	var tempBuffer = new Buffer(this.offset + this.rawSize);
	this.pos = 0;
	tempBuffer.write(this.flag, this.pos);				this.pos+=2;
	tempBuffer.writeUInt32LE(this.fileSize, this.pos);	this.pos+=4;
	tempBuffer.writeUInt32LE(this.reserved, this.pos);	this.pos+=4;
	tempBuffer.writeUInt32LE(this.offset, this.pos);	this.pos+=4;

	tempBuffer.writeUInt32LE(this.headerSize, this.pos);this.pos+=4;
	tempBuffer.writeUInt32LE(this.width, this.pos);		this.pos+=4;
	tempBuffer.writeUInt32LE(this.height, this.pos);	this.pos+=4;
	tempBuffer.writeUInt16LE(this.planes, this.pos);	this.pos+=2;

if (this.bitPP > 0)
{	tempBuffer.writeUInt16LE(this.bitPP, this.pos);		this.pos+=2;}
else
{	tempBuffer.writeUInt16LE(-this.bitPP, this.pos);	this.pos+=2;}

	tempBuffer.writeUInt32LE(this.compress, this.pos);	this.pos+=4;
	tempBuffer.writeUInt32LE(this.rawSize, this.pos);	this.pos+=4;
	tempBuffer.writeUInt32LE(this.hr, this.pos);		this.pos+=4;
	tempBuffer.writeUInt32LE(this.vr, this.pos);		this.pos+=4;
	tempBuffer.writeUInt32LE(this.colors, this.pos);	this.pos+=4;
	tempBuffer.writeUInt32LE(this.importantColors, this.pos);this.pos+=4;

/*
console.log("fileSize=" + this.fileSize);
console.log("reserved=" + this.reserved);
console.log("offset=" + this.offset);
console.log("headerSize=" + this.headerSize);
console.log("width=" + this.width);
console.log("height=" + this.height);
console.log("planes=" + this.planes);
console.log("bitPP=" + this.bitPP);
console.log("compress=" + this.compress);
console.log("rawSize=" + this.rawSize);
console.log("hr=" + this.hr);
console.log("vr=" + this.vr);
console.log("colors=" + this.colors);
console.log("importantColors=" + this.importantColors);
*/
	if (this.bitPP < 24) {
	//	var len = 1 << this.bitPP;
		var len = this.bitPP > 0 ? (1 << this.bitPP) : (1 << -this.bitPP);
		for (var i = 0; i < len; i++) {
			tempBuffer.writeUInt8(i, this.pos); this.pos++;
			tempBuffer.writeUInt8(i, this.pos); this.pos++;
			tempBuffer.writeUInt8(i, this.pos); this.pos++;
			tempBuffer.writeUInt8(0, this.pos); this.pos++;
		}
	}

	var i=0, rowBytes;
	if (this.bitPP == 24) rowBytes = 3 * this.width + this.extraBytes;
	else if (this.bitPP == 8) rowBytes = this.width + this.extraBytes;
	else if (this.bitPP == -8) rowBytes = this.width + this.extraBytes;

	if (this.bitPP == 24) {
		for (var y = this.height - 1; y >= 0; y--){
			for (var x = 0; x < this.width; x++){
				var p = this.pos + y * rowBytes + x * 3;
				tempBuffer[p+2] = this.buffer[i++];//r
				tempBuffer[p+1] = this.buffer[i++];//g
				tempBuffer[p]   = this.buffer[i++];//b
			}
			if(this.extraBytes > 0){
				var fillOffset = this.pos + y * rowBytes + this.width * 3;
				tempBuffer.fill(0, fillOffset, fillOffset + this.extraBytes);
			}
		}
	}
	else if (this.bitPP == 8) {
//		for (var y = this.height - 1; y >= 0; y--){
		for (var y = 0; y < this.height; y++){
			for (var x = 0; x < this.width; x++){
				var p = this.pos + y * rowBytes + x;
				tempBuffer[p] = this.buffer[i++];
			}
			if(this.extraBytes > 0){
				var fillOffset = this.pos + y * rowBytes + this.width;
				tempBuffer.fill(0, fillOffset, fillOffset + this.extraBytes);
			}
		}
	}
	else if (this.bitPP == -8) {
		for (var y = this.height - 1; y >= 0; y--){
			for (var x = 0; x < this.width; x++){
				var p = this.pos + y * rowBytes + x;
				tempBuffer[p] = this.buffer[i++];
			}
			if(this.extraBytes > 0){
				var fillOffset = this.pos + y * rowBytes + this.width;
				tempBuffer.fill(0, fillOffset, fillOffset + this.extraBytes);
			}
		}
	}

	return tempBuffer;
};

}

module.exports = BmpEncoder;
/*
.prototypeencode = function(imgData, b, w, h) {
//	if (typeof quality === 'undefined') quality = 100;
	quality = 100;
	var encoder = new BmpEncoder(imgData, b, w, h);
	var data = encoder.encode();
	return {
		data: data,
		width: w,
		height: h
	};
}
*/