/*
	細線化の比較
	Created by T. Osaka(2015/8/26)

	usage
		node bmpT.js b1.bmp 128
*/

var fs = require("fs");
var bmp = require("./bmp-js");
var BmpEncoder = require("./bmp-js/lib/encoder.js");
var Thin = require("./thin.js");

var filename = process.argv[2];
var threshold = process.argv[3];

var bmpBuffer = fs.readFileSync(filename);
var bmpData = bmp.decode(bmpBuffer);
console.log(bmpData.width + " " + bmpData.height + " " + bmpData.data.length + " " + bmpData.pixels.length);

var width = bmpData.width;
var height = bmpData.height;

fileout(bmpData.pixels, filename+".t.bmp", 8, width, height);

//frequency(bmpData.pixels, width, height);
var data0 = binarization(bmpData.pixels, width, height, threshold);

// -------------------------------
	var data1 = new Buffer(width * height);
	var data2 = new Buffer(width * height);
	var data3 = new Buffer(width * height);
	var data4 = new Buffer(width * height);
	for (var i = 0; i < width * height; i++) {
		data1[i] = data0[i];
		data2[i] = data0[i];
		data3[i] = data0[i];
		data4[i] = data0[i];
	}

var thin = new Thin();

// -------------------------------

var s0 = new Date().getTime();
	thin.ZhangSuen(data1, width, height, 1, 1, width - 1, height - 1);
	var datat1 = thin.getData();
var s1 = new Date().getTime();
// -------------------------------

var s2 = new Date().getTime();
	thin.zhang_suen(data2, width, height, 1, 1, width - 1, height - 1);
	var datat2 = thin.getData();
var s3 = new Date().getTime();
// -------------------------------

var s4 = new Date().getTime();
	thin.nwg_method(data3, width, height, 1, 1, width - 1, height - 1);
	var datat3 = thin.getData();
var s5 = new Date().getTime();
// -------------------------------

var s6 = new Date().getTime();
	thin.tamura(data4, width, height, 1, 1, width - 1, height - 1);
	var datat4 = thin.getData();
var s7 = new Date().getTime();
// -------------------------------

console.log("thin1="+ (s1-s0)+ " thin2="+ (s3-s2)+ " thin3="+ (s5-s4)+ " thin4="+ (s7-s6));
//103.1 47.1 49.5 38.5
//116.7	51.9	51..2	41.6

//細線化画像のBMP出力
fileout( data0, filename+".t0.bmp", 8, width, height);
fileout(datat1, filename+".t1.bmp", 8, width, height);
fileout(datat2, filename+".t2.bmp", 8, width, height);
fileout(datat3, filename+".t3.bmp", 8, width, height);
fileout(datat4, filename+".t4.bmp", 8, width, height);

// --------------------------------------------------------------------

function fileout(imgData, filename, bit, w, h) {
	var encoder = new BmpEncoder(imgData, bit, w, h);
	var data = encoder.encode();
	fs.writeFile(filename, data);
}

function binarization(data, w, h, threshold){
	var q = new Buffer(w * h);
	for (var i = 0; i < w * h; i++) {
		q[i] = data[i] > threshold ? 0xff : 0x00;;
	}
	return q;
}

function frequency(data, w, h){
	var fq = new Array(256);
	for (var i=0; i < 256; i++) fq[i] = 0;
	for (var i = 0; i < w * h; i++) {
		fq[data[i]]++;
	}

	for (var i in fq) {
		if(fq[i] != 0) console.log(i + " : " + fq[i]);
	}
	return fq;
}
